<?php


namespace OrganizationsManagement\Repository;


use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class CadastroAssunto
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * Classification constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findTreeGridSubject($fetchOnDemand, $fetchOnDemandPrimeiraLinha)
    {
        $query = <<<SQL
            SELECT OQA.ID, OQA.PAI_ID, OQA.DSASSUNTO, OQA.IDATIVO, DECODE(OQP.PAI_ID, NULL, 0, 1) AS NODE_TREE_HAS_CHILD
            FROM OM_OQA_ASSUNTO OQA
            LEFT JOIN (SELECT DISTINCT PAI_ID
                        FROM OM_OQA_ASSUNTO) OQP
                        ON OQP.PAI_ID = OQA.ID
            WHERE IDATIVO = 'S'
            $fetchOnDemand
            $fetchOnDemandPrimeiraLinha

SQL;
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query);
    }
}
